# this module reads a command from the task module,
# passes it to the tuner, collects the first string
# from its stdout and sends it to the queue

from multiprocessing import cpu_count
from multiprocessing.managers import BaseManager
from subprocess import Popen, PIPE
from threading import Thread
import connection, time
import urllib2

class MyClient():
    def __init__(self,address,port,password):
        
        class MyManager(BaseManager): pass
        MyManager.register('get_queue')
        MyManager.register('get_command')
        MyManager.register('set_command')

        print 'Connecting to server '+address+':'+repr(port)
        self.manager = MyManager(address = (address,port), authkey = password)
        self.manager.connect()

        self.queue = self.manager.get_queue()
        self.command = self.manager.get_command()
        print 'Connected\n'

def run():
    while True:
        try:
            client = MyClient(connection.TASK_ADDRESS,connection.TASK_PORT,connection.TASK_PASSWORD)
            print 'Launching tuner\n'
            tuner = Popen('./Client/Gull.exe client', stdin = PIPE, stdout = PIPE)
            print 'Tuner launched\n'
            while True:
                command = ''
                while ('$' not in command):
                    command = str(client.manager.get_command())
                #print '<--- '+command
                tuner.stdin.flush()
                tuner.stdin.write(command+'\n')
                #print '-> '+command
                line = ''
                while ('$' not in line):
                    line = tuner.stdout.readline()
                    #if ('$' not in line): print line      
                #print '---> '+line
                client.queue.put(line)
        except Exception as e:
            tuner.kill()
            print e
            time.sleep(1)
        
if __name__ == '__main__':
    f = urllib2.urlopen('http://'+connection.TASK_ADDRESS+':8000/HTTP/Gull.cpp')
    data = f.read()
    with open("./Client/Gull.cpp", "wb") as mfile:
        mfile.write(data)

    f = urllib2.urlopen('http://'+connection.TASK_ADDRESS+':8000/HTTP/Gull.exe')
    data = f.read()
    with open("./Client/Gull.exe", "wb") as mfile:
        mfile.write(data)
        
    if connection.CLIENT_PROCESS_NUMBER == 0:
        process_number = cpu_count() - 1
        if process_number == 0:
            process_number = 1
    else:
        process_number = connection.CLIENT_PROCESS_NUMBER
    for i in range(process_number):
        t = Thread(target = run)
        t.start()
    
            
